#ifndef SCANNERSTWOHMD_H
#define SCANNERSTWOHMD_H
#include <iostream>
#include "../../ScannerSInterface.h"
#include "../../ScannerSModelclasses.h"
#include "../../ScannerSTables.h"
#include "../../ScannerSEWPO.h"
#include "../../ScannerSAnalysisUtils.h"



#include "../../ExtInterfaces/Wrappers.h"


class TwoHDM:public Potential{
//UNDER CONSTRUCTION!!!!!!!!!!!!
    static std::string filepath;
    static int nHzero;
    static int nHplus;
    std::vector<double> MassBeta;//vector to call table of flavour physics observables 

    double Rhvv[3];
    double Rhhv[3][3];
	//Higgs couplings to fermions indices are: 
	// Rhfs[Type][iHiggs][ifermion]: Type=0,1,2,3 (I, II, III, IV); iHiggs=0,1,2 (h,A,H), ifermion= 0,1,2 (up-type quarks, d-type quarks and fermions)
    double Rhf[3][3];
    double alphaSM;
  
    double bsgamma,Pvalue;
#ifdef HBMODE
    HBobject HiggsBoundsAnalysis;
    void PrepareHiggsBoundsInput();    
#endif
    bool mass_bounds[8],L_bounds[8],phi_bounds[8];
    int Type2HDM;
  public:
    double mHheavy,mHlight,mHcharged,mA,alpha,beta,tanbeta,bsgamma_max,bsgamma_min,Ecm2,Ecm7,Ecm8;
      
    static int whichanalyses;
    static int whichinput;    
    
    TwoHDM();
    void PrintHeader();
    void readfile(std::istream & in);
    void UserInitCalcs();
    void what2print();
    bool CheckBounds();
    bool CheckStability(LambdaRef & L)const;
    bool CheckGlobal(PhiRef & Phi,LambdaRef & L,Potential & V)const;
    bool UserAnalysis(PhiRef & Phi,LambdaRef & L,MassRef & Mass, MmixingRef & Mixing);
    std::string name();
    bool Test_bs_gamma(); 
    
    void MyPhiParametrization(const PhiParamVec & PhiPar,PhiVec & Phi);
    void MyInternalMixing(const PhiParamVec & PhiPar,const PhiVec & Phi,MixingparamVec & MixPar,std::vector< std::vector<double> > & MixInternal);
    void MyCoupMassRelations(const PhiParamVec & PhiPar,const PhiVec & Phi,const std::vector< std::vector<double> > & Mixing,const MixingparamVec & MixPar,std::vector<double> & L,std::vector<double> & Mass, MLparamVec & MLPar, std::vector<double> & IndependentMs,std::vector<double> & IndependentLs);
 
  private:
    void PhysicalStates2HDM();
    bool TestZbbarbLEP();

};

void PhysicalStates2HDM(MassRef & Mass, MmixingRef & Mixing,PhiRef & Phi,double & mHheavy, double & mhlight, double & mHc, double & mA, double & alpha,double & beta);

void LoadAll2HDMTables(void);

double InternalTableSusHiPP(double Ecm, double mHparticle, double alpha,double tanbeta,int Hparticle,int Type2HDM);

double InternalTableSusHiPPbar(double Ecm, double mHparticle, double alpha,double tanbeta,int Hparticle,int Type2HDM);

// SuperisoTables for B->X_s gamma to be available for User

extern TableData TableSuperisoBsgammaType1;
extern TableData TableSuperisoBsgammaType2;
extern TableData TableSuperisoBsgammaType3;
extern TableData TableSuperisoBsgammaType4;

// SushiTables to be available for User

/// Tables for CP odd higgs

extern TableData TableSusHiFuncBB_mrange30_330Ecm7_14pp;
extern TableData TableSusHiFuncBB_mrange330_360Ecm7_14pp;
extern TableData TableSusHiFuncBB_mrange360_1000Ecm7_14pp;
extern TableData TableSusHiFuncTB_mrange30_330Ecm7_14pp;
extern TableData TableSusHiFuncTB_mrange330_360Ecm7_14pp;
extern TableData TableSusHiFuncTB_mrange360_1000Ecm7_14pp;
extern TableData TableSusHiFuncTT_mrange30_330Ecm7_14pp;
extern TableData TableSusHiFuncTT_mrange330_360Ecm7_14pp;
extern TableData TableSusHiFuncTT_mrange360_1000Ecm7_14pp;

//PPbar collider
extern TableData TableSusHiFuncBB_mrange30_330Ecm0_5_2ppbar;
extern TableData TableSusHiFuncBB_mrange330_360Ecm0_5_2ppbar;
extern TableData TableSusHiFuncBB_mrange360_450Ecm0_5_1ppbar;
extern TableData TableSusHiFuncBB_mrange360_950Ecm1_1_5ppbar;
extern TableData TableSusHiFuncBB_mrange360_1000Ecm1_5_2ppbar;
extern TableData TableSusHiFuncTB_mrange30_330Ecm0_5_2ppbar;
extern TableData TableSusHiFuncTB_mrange330_360Ecm0_5_2ppbar;
extern TableData TableSusHiFuncTB_mrange360_450Ecm0_5_1ppbar;
extern TableData TableSusHiFuncTB_mrange360_950Ecm1_1_5ppbar;
extern TableData TableSusHiFuncTB_mrange360_1000Ecm1_5_2ppbar;
extern TableData TableSusHiFuncTT_mrange30_330Ecm0_5_2ppbar;
extern TableData TableSusHiFuncTT_mrange330_360Ecm0_5_2ppbar;
extern TableData TableSusHiFuncTT_mrange360_450Ecm0_5_1ppbar;
extern TableData TableSusHiFuncTT_mrange360_950Ecm1_1_5ppbar;
extern TableData TableSusHiFuncTT_mrange360_1000Ecm1_5_2ppbar;

/// Tables for CP odd higgs

extern TableData TableSusHiAFuncBB_mrange30_330Ecm7_14pp;
extern TableData TableSusHiAFuncBB_mrange330_360Ecm7_14pp;
extern TableData TableSusHiAFuncBB_mrange360_1000Ecm7_14pp;
extern TableData TableSusHiAFuncTB_mrange30_330Ecm7_14pp;
extern TableData TableSusHiAFuncTB_mrange330_360Ecm7_14pp;
extern TableData TableSusHiAFuncTB_mrange360_1000Ecm7_14pp;
extern TableData TableSusHiAFuncTT_mrange30_330Ecm7_14pp;
extern TableData TableSusHiAFuncTT_mrange330_360Ecm7_14pp;
extern TableData TableSusHiAFuncTT_mrange360_1000Ecm7_14pp;

//PPbar collider
extern TableData TableSusHiAFuncBB_mrange30_330Ecm0_5_2ppbar;
extern TableData TableSusHiAFuncBB_mrange330_360Ecm0_5_2ppbar;
extern TableData TableSusHiAFuncBB_mrange360_450Ecm0_5_1ppbar;
extern TableData TableSusHiAFuncBB_mrange360_950Ecm1_1_5ppbar;
extern TableData TableSusHiAFuncBB_mrange360_1000Ecm1_5_2ppbar;
extern TableData TableSusHiAFuncTB_mrange30_330Ecm0_5_2ppbar;
extern TableData TableSusHiAFuncTB_mrange330_360Ecm0_5_2ppbar;
extern TableData TableSusHiAFuncTB_mrange360_450Ecm0_5_1ppbar;
extern TableData TableSusHiAFuncTB_mrange360_950Ecm1_1_5ppbar;
extern TableData TableSusHiAFuncTB_mrange360_1000Ecm1_5_2ppbar;
extern TableData TableSusHiAFuncTT_mrange30_330Ecm0_5_2ppbar;
extern TableData TableSusHiAFuncTT_mrange330_360Ecm0_5_2ppbar;
extern TableData TableSusHiAFuncTT_mrange360_450Ecm0_5_1ppbar;
extern TableData TableSusHiAFuncTT_mrange360_950Ecm1_1_5ppbar;
extern TableData TableSusHiAFuncTT_mrange360_1000Ecm1_5_2ppbar;


#endif
